// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: regulatormodule/regulatormodule.proto

package openfmb.regulatormodule;

/**
 * <pre>
 * LN: Automatic tap changer controller   Name: ATCC
 * </pre>
 *
 * Protobuf type {@code regulatormodule.DirectionalATCC}
 */
public final class DirectionalATCC extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:regulatormodule.DirectionalATCC)
    DirectionalATCCOrBuilder {
private static final long serialVersionUID = 0L;
  // Use DirectionalATCC.newBuilder() to construct.
  private DirectionalATCC(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private DirectionalATCC() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new DirectionalATCC();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_DirectionalATCC_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_DirectionalATCC_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.regulatormodule.DirectionalATCC.class, openfmb.regulatormodule.DirectionalATCC.Builder.class);
  }

  public static final int BNDWID_FIELD_NUMBER = 1;
  private openfmb.commonmodule.PhaseAPC bndWid_;
  /**
   * <pre>
   * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
   * of the nominal voltage (forward power flow presumed).
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
   * @return Whether the bndWid field is set.
   */
  @java.lang.Override
  public boolean hasBndWid() {
    return bndWid_ != null;
  }
  /**
   * <pre>
   * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
   * of the nominal voltage (forward power flow presumed).
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
   * @return The bndWid.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseAPC getBndWid() {
    return bndWid_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : bndWid_;
  }
  /**
   * <pre>
   * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
   * of the nominal voltage (forward power flow presumed).
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseAPCOrBuilder getBndWidOrBuilder() {
    return bndWid_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : bndWid_;
  }

  public static final int CTLDLTMMS_FIELD_NUMBER = 2;
  private openfmb.commonmodule.PhaseISC ctlDlTmms_;
  /**
   * <pre>
   * Time to wait before operating, after reaching the control point (forward power flow presumed).
   * </pre>
   *
   * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
   * @return Whether the ctlDlTmms field is set.
   */
  @java.lang.Override
  public boolean hasCtlDlTmms() {
    return ctlDlTmms_ != null;
  }
  /**
   * <pre>
   * Time to wait before operating, after reaching the control point (forward power flow presumed).
   * </pre>
   *
   * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
   * @return The ctlDlTmms.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseISC getCtlDlTmms() {
    return ctlDlTmms_ == null ? openfmb.commonmodule.PhaseISC.getDefaultInstance() : ctlDlTmms_;
  }
  /**
   * <pre>
   * Time to wait before operating, after reaching the control point (forward power flow presumed).
   * </pre>
   *
   * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseISCOrBuilder getCtlDlTmmsOrBuilder() {
    return ctlDlTmms_ == null ? openfmb.commonmodule.PhaseISC.getDefaultInstance() : ctlDlTmms_;
  }

  public static final int LDCR_FIELD_NUMBER = 3;
  private openfmb.commonmodule.PhaseAPC lDCR_;
  /**
   * <pre>
   * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
   * @return Whether the lDCR field is set.
   */
  @java.lang.Override
  public boolean hasLDCR() {
    return lDCR_ != null;
  }
  /**
   * <pre>
   * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
   * @return The lDCR.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseAPC getLDCR() {
    return lDCR_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : lDCR_;
  }
  /**
   * <pre>
   * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseAPCOrBuilder getLDCROrBuilder() {
    return lDCR_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : lDCR_;
  }

  public static final int LDCX_FIELD_NUMBER = 4;
  private openfmb.commonmodule.PhaseAPC lDCX_;
  /**
   * <pre>
   * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
   * @return Whether the lDCX field is set.
   */
  @java.lang.Override
  public boolean hasLDCX() {
    return lDCX_ != null;
  }
  /**
   * <pre>
   * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
   * @return The lDCX.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseAPC getLDCX() {
    return lDCX_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : lDCX_;
  }
  /**
   * <pre>
   * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseAPCOrBuilder getLDCXOrBuilder() {
    return lDCX_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : lDCX_;
  }

  public static final int VOLSPT_FIELD_NUMBER = 5;
  private openfmb.commonmodule.PhaseAPC volSpt_;
  /**
   * <pre>
   * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
   * @return Whether the volSpt field is set.
   */
  @java.lang.Override
  public boolean hasVolSpt() {
    return volSpt_ != null;
  }
  /**
   * <pre>
   * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
   * @return The volSpt.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseAPC getVolSpt() {
    return volSpt_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : volSpt_;
  }
  /**
   * <pre>
   * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
   * </pre>
   *
   * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseAPCOrBuilder getVolSptOrBuilder() {
    return volSpt_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : volSpt_;
  }

  public static final int VOLTAGESETPOINTENABLED_FIELD_NUMBER = 6;
  private openfmb.commonmodule.PhaseDPC voltageSetPointEnabled_;
  /**
   * <pre>
   * Enable voltage set point
   * </pre>
   *
   * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
   * @return Whether the voltageSetPointEnabled field is set.
   */
  @java.lang.Override
  public boolean hasVoltageSetPointEnabled() {
    return voltageSetPointEnabled_ != null;
  }
  /**
   * <pre>
   * Enable voltage set point
   * </pre>
   *
   * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
   * @return The voltageSetPointEnabled.
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseDPC getVoltageSetPointEnabled() {
    return voltageSetPointEnabled_ == null ? openfmb.commonmodule.PhaseDPC.getDefaultInstance() : voltageSetPointEnabled_;
  }
  /**
   * <pre>
   * Enable voltage set point
   * </pre>
   *
   * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.PhaseDPCOrBuilder getVoltageSetPointEnabledOrBuilder() {
    return voltageSetPointEnabled_ == null ? openfmb.commonmodule.PhaseDPC.getDefaultInstance() : voltageSetPointEnabled_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (bndWid_ != null) {
      output.writeMessage(1, getBndWid());
    }
    if (ctlDlTmms_ != null) {
      output.writeMessage(2, getCtlDlTmms());
    }
    if (lDCR_ != null) {
      output.writeMessage(3, getLDCR());
    }
    if (lDCX_ != null) {
      output.writeMessage(4, getLDCX());
    }
    if (volSpt_ != null) {
      output.writeMessage(5, getVolSpt());
    }
    if (voltageSetPointEnabled_ != null) {
      output.writeMessage(6, getVoltageSetPointEnabled());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (bndWid_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getBndWid());
    }
    if (ctlDlTmms_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getCtlDlTmms());
    }
    if (lDCR_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getLDCR());
    }
    if (lDCX_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getLDCX());
    }
    if (volSpt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getVolSpt());
    }
    if (voltageSetPointEnabled_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getVoltageSetPointEnabled());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.regulatormodule.DirectionalATCC)) {
      return super.equals(obj);
    }
    openfmb.regulatormodule.DirectionalATCC other = (openfmb.regulatormodule.DirectionalATCC) obj;

    if (hasBndWid() != other.hasBndWid()) return false;
    if (hasBndWid()) {
      if (!getBndWid()
          .equals(other.getBndWid())) return false;
    }
    if (hasCtlDlTmms() != other.hasCtlDlTmms()) return false;
    if (hasCtlDlTmms()) {
      if (!getCtlDlTmms()
          .equals(other.getCtlDlTmms())) return false;
    }
    if (hasLDCR() != other.hasLDCR()) return false;
    if (hasLDCR()) {
      if (!getLDCR()
          .equals(other.getLDCR())) return false;
    }
    if (hasLDCX() != other.hasLDCX()) return false;
    if (hasLDCX()) {
      if (!getLDCX()
          .equals(other.getLDCX())) return false;
    }
    if (hasVolSpt() != other.hasVolSpt()) return false;
    if (hasVolSpt()) {
      if (!getVolSpt()
          .equals(other.getVolSpt())) return false;
    }
    if (hasVoltageSetPointEnabled() != other.hasVoltageSetPointEnabled()) return false;
    if (hasVoltageSetPointEnabled()) {
      if (!getVoltageSetPointEnabled()
          .equals(other.getVoltageSetPointEnabled())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasBndWid()) {
      hash = (37 * hash) + BNDWID_FIELD_NUMBER;
      hash = (53 * hash) + getBndWid().hashCode();
    }
    if (hasCtlDlTmms()) {
      hash = (37 * hash) + CTLDLTMMS_FIELD_NUMBER;
      hash = (53 * hash) + getCtlDlTmms().hashCode();
    }
    if (hasLDCR()) {
      hash = (37 * hash) + LDCR_FIELD_NUMBER;
      hash = (53 * hash) + getLDCR().hashCode();
    }
    if (hasLDCX()) {
      hash = (37 * hash) + LDCX_FIELD_NUMBER;
      hash = (53 * hash) + getLDCX().hashCode();
    }
    if (hasVolSpt()) {
      hash = (37 * hash) + VOLSPT_FIELD_NUMBER;
      hash = (53 * hash) + getVolSpt().hashCode();
    }
    if (hasVoltageSetPointEnabled()) {
      hash = (37 * hash) + VOLTAGESETPOINTENABLED_FIELD_NUMBER;
      hash = (53 * hash) + getVoltageSetPointEnabled().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.regulatormodule.DirectionalATCC parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.regulatormodule.DirectionalATCC parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.regulatormodule.DirectionalATCC prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * LN: Automatic tap changer controller   Name: ATCC
   * </pre>
   *
   * Protobuf type {@code regulatormodule.DirectionalATCC}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:regulatormodule.DirectionalATCC)
      openfmb.regulatormodule.DirectionalATCCOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_DirectionalATCC_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_DirectionalATCC_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.regulatormodule.DirectionalATCC.class, openfmb.regulatormodule.DirectionalATCC.Builder.class);
    }

    // Construct using openfmb.regulatormodule.DirectionalATCC.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      bndWid_ = null;
      if (bndWidBuilder_ != null) {
        bndWidBuilder_.dispose();
        bndWidBuilder_ = null;
      }
      ctlDlTmms_ = null;
      if (ctlDlTmmsBuilder_ != null) {
        ctlDlTmmsBuilder_.dispose();
        ctlDlTmmsBuilder_ = null;
      }
      lDCR_ = null;
      if (lDCRBuilder_ != null) {
        lDCRBuilder_.dispose();
        lDCRBuilder_ = null;
      }
      lDCX_ = null;
      if (lDCXBuilder_ != null) {
        lDCXBuilder_.dispose();
        lDCXBuilder_ = null;
      }
      volSpt_ = null;
      if (volSptBuilder_ != null) {
        volSptBuilder_.dispose();
        volSptBuilder_ = null;
      }
      voltageSetPointEnabled_ = null;
      if (voltageSetPointEnabledBuilder_ != null) {
        voltageSetPointEnabledBuilder_.dispose();
        voltageSetPointEnabledBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.regulatormodule.Regulatormodule.internal_static_regulatormodule_DirectionalATCC_descriptor;
    }

    @java.lang.Override
    public openfmb.regulatormodule.DirectionalATCC getDefaultInstanceForType() {
      return openfmb.regulatormodule.DirectionalATCC.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.regulatormodule.DirectionalATCC build() {
      openfmb.regulatormodule.DirectionalATCC result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.regulatormodule.DirectionalATCC buildPartial() {
      openfmb.regulatormodule.DirectionalATCC result = new openfmb.regulatormodule.DirectionalATCC(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.regulatormodule.DirectionalATCC result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.bndWid_ = bndWidBuilder_ == null
            ? bndWid_
            : bndWidBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.ctlDlTmms_ = ctlDlTmmsBuilder_ == null
            ? ctlDlTmms_
            : ctlDlTmmsBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.lDCR_ = lDCRBuilder_ == null
            ? lDCR_
            : lDCRBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.lDCX_ = lDCXBuilder_ == null
            ? lDCX_
            : lDCXBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.volSpt_ = volSptBuilder_ == null
            ? volSpt_
            : volSptBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.voltageSetPointEnabled_ = voltageSetPointEnabledBuilder_ == null
            ? voltageSetPointEnabled_
            : voltageSetPointEnabledBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.regulatormodule.DirectionalATCC) {
        return mergeFrom((openfmb.regulatormodule.DirectionalATCC)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.regulatormodule.DirectionalATCC other) {
      if (other == openfmb.regulatormodule.DirectionalATCC.getDefaultInstance()) return this;
      if (other.hasBndWid()) {
        mergeBndWid(other.getBndWid());
      }
      if (other.hasCtlDlTmms()) {
        mergeCtlDlTmms(other.getCtlDlTmms());
      }
      if (other.hasLDCR()) {
        mergeLDCR(other.getLDCR());
      }
      if (other.hasLDCX()) {
        mergeLDCX(other.getLDCX());
      }
      if (other.hasVolSpt()) {
        mergeVolSpt(other.getVolSpt());
      }
      if (other.hasVoltageSetPointEnabled()) {
        mergeVoltageSetPointEnabled(other.getVoltageSetPointEnabled());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getBndWidFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getCtlDlTmmsFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getLDCRFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getLDCXFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getVolSptFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getVoltageSetPointEnabledFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.PhaseAPC bndWid_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder> bndWidBuilder_;
    /**
     * <pre>
     * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
     * of the nominal voltage (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
     * @return Whether the bndWid field is set.
     */
    public boolean hasBndWid() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
     * of the nominal voltage (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
     * @return The bndWid.
     */
    public openfmb.commonmodule.PhaseAPC getBndWid() {
      if (bndWidBuilder_ == null) {
        return bndWid_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : bndWid_;
      } else {
        return bndWidBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
     * of the nominal voltage (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
     */
    public Builder setBndWid(openfmb.commonmodule.PhaseAPC value) {
      if (bndWidBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        bndWid_ = value;
      } else {
        bndWidBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
     * of the nominal voltage (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
     */
    public Builder setBndWid(
        openfmb.commonmodule.PhaseAPC.Builder builderForValue) {
      if (bndWidBuilder_ == null) {
        bndWid_ = builderForValue.build();
      } else {
        bndWidBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
     * of the nominal voltage (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
     */
    public Builder mergeBndWid(openfmb.commonmodule.PhaseAPC value) {
      if (bndWidBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          bndWid_ != null &&
          bndWid_ != openfmb.commonmodule.PhaseAPC.getDefaultInstance()) {
          getBndWidBuilder().mergeFrom(value);
        } else {
          bndWid_ = value;
        }
      } else {
        bndWidBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
     * of the nominal voltage (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
     */
    public Builder clearBndWid() {
      bitField0_ = (bitField0_ & ~0x00000001);
      bndWid_ = null;
      if (bndWidBuilder_ != null) {
        bndWidBuilder_.dispose();
        bndWidBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
     * of the nominal voltage (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
     */
    public openfmb.commonmodule.PhaseAPC.Builder getBndWidBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getBndWidFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
     * of the nominal voltage (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
     */
    public openfmb.commonmodule.PhaseAPCOrBuilder getBndWidOrBuilder() {
      if (bndWidBuilder_ != null) {
        return bndWidBuilder_.getMessageOrBuilder();
      } else {
        return bndWid_ == null ?
            openfmb.commonmodule.PhaseAPC.getDefaultInstance() : bndWid_;
      }
    }
    /**
     * <pre>
     * Control (secondary) voltage bandwidth (i.e., range), given either as voltage value or percentage
     * of the nominal voltage (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC BndWid = 1;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder> 
        getBndWidFieldBuilder() {
      if (bndWidBuilder_ == null) {
        bndWidBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder>(
                getBndWid(),
                getParentForChildren(),
                isClean());
        bndWid_ = null;
      }
      return bndWidBuilder_;
    }

    private openfmb.commonmodule.PhaseISC ctlDlTmms_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseISC, openfmb.commonmodule.PhaseISC.Builder, openfmb.commonmodule.PhaseISCOrBuilder> ctlDlTmmsBuilder_;
    /**
     * <pre>
     * Time to wait before operating, after reaching the control point (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
     * @return Whether the ctlDlTmms field is set.
     */
    public boolean hasCtlDlTmms() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Time to wait before operating, after reaching the control point (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
     * @return The ctlDlTmms.
     */
    public openfmb.commonmodule.PhaseISC getCtlDlTmms() {
      if (ctlDlTmmsBuilder_ == null) {
        return ctlDlTmms_ == null ? openfmb.commonmodule.PhaseISC.getDefaultInstance() : ctlDlTmms_;
      } else {
        return ctlDlTmmsBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Time to wait before operating, after reaching the control point (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
     */
    public Builder setCtlDlTmms(openfmb.commonmodule.PhaseISC value) {
      if (ctlDlTmmsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ctlDlTmms_ = value;
      } else {
        ctlDlTmmsBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Time to wait before operating, after reaching the control point (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
     */
    public Builder setCtlDlTmms(
        openfmb.commonmodule.PhaseISC.Builder builderForValue) {
      if (ctlDlTmmsBuilder_ == null) {
        ctlDlTmms_ = builderForValue.build();
      } else {
        ctlDlTmmsBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Time to wait before operating, after reaching the control point (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
     */
    public Builder mergeCtlDlTmms(openfmb.commonmodule.PhaseISC value) {
      if (ctlDlTmmsBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          ctlDlTmms_ != null &&
          ctlDlTmms_ != openfmb.commonmodule.PhaseISC.getDefaultInstance()) {
          getCtlDlTmmsBuilder().mergeFrom(value);
        } else {
          ctlDlTmms_ = value;
        }
      } else {
        ctlDlTmmsBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Time to wait before operating, after reaching the control point (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
     */
    public Builder clearCtlDlTmms() {
      bitField0_ = (bitField0_ & ~0x00000002);
      ctlDlTmms_ = null;
      if (ctlDlTmmsBuilder_ != null) {
        ctlDlTmmsBuilder_.dispose();
        ctlDlTmmsBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Time to wait before operating, after reaching the control point (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
     */
    public openfmb.commonmodule.PhaseISC.Builder getCtlDlTmmsBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getCtlDlTmmsFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Time to wait before operating, after reaching the control point (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
     */
    public openfmb.commonmodule.PhaseISCOrBuilder getCtlDlTmmsOrBuilder() {
      if (ctlDlTmmsBuilder_ != null) {
        return ctlDlTmmsBuilder_.getMessageOrBuilder();
      } else {
        return ctlDlTmms_ == null ?
            openfmb.commonmodule.PhaseISC.getDefaultInstance() : ctlDlTmms_;
      }
    }
    /**
     * <pre>
     * Time to wait before operating, after reaching the control point (forward power flow presumed).
     * </pre>
     *
     * <code>.commonmodule.PhaseISC CtlDlTmms = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseISC, openfmb.commonmodule.PhaseISC.Builder, openfmb.commonmodule.PhaseISCOrBuilder> 
        getCtlDlTmmsFieldBuilder() {
      if (ctlDlTmmsBuilder_ == null) {
        ctlDlTmmsBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseISC, openfmb.commonmodule.PhaseISC.Builder, openfmb.commonmodule.PhaseISCOrBuilder>(
                getCtlDlTmms(),
                getParentForChildren(),
                isClean());
        ctlDlTmms_ = null;
      }
      return ctlDlTmmsBuilder_;
    }

    private openfmb.commonmodule.PhaseAPC lDCR_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder> lDCRBuilder_;
    /**
     * <pre>
     * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
     * @return Whether the lDCR field is set.
     */
    public boolean hasLDCR() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
     * @return The lDCR.
     */
    public openfmb.commonmodule.PhaseAPC getLDCR() {
      if (lDCRBuilder_ == null) {
        return lDCR_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : lDCR_;
      } else {
        return lDCRBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
     */
    public Builder setLDCR(openfmb.commonmodule.PhaseAPC value) {
      if (lDCRBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        lDCR_ = value;
      } else {
        lDCRBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
     */
    public Builder setLDCR(
        openfmb.commonmodule.PhaseAPC.Builder builderForValue) {
      if (lDCRBuilder_ == null) {
        lDCR_ = builderForValue.build();
      } else {
        lDCRBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
     */
    public Builder mergeLDCR(openfmb.commonmodule.PhaseAPC value) {
      if (lDCRBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          lDCR_ != null &&
          lDCR_ != openfmb.commonmodule.PhaseAPC.getDefaultInstance()) {
          getLDCRBuilder().mergeFrom(value);
        } else {
          lDCR_ = value;
        }
      } else {
        lDCRBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
     */
    public Builder clearLDCR() {
      bitField0_ = (bitField0_ & ~0x00000004);
      lDCR_ = null;
      if (lDCRBuilder_ != null) {
        lDCRBuilder_.dispose();
        lDCRBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
     */
    public openfmb.commonmodule.PhaseAPC.Builder getLDCRBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getLDCRFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
     */
    public openfmb.commonmodule.PhaseAPCOrBuilder getLDCROrBuilder() {
      if (lDCRBuilder_ != null) {
        return lDCRBuilder_.getMessageOrBuilder();
      } else {
        return lDCR_ == null ?
            openfmb.commonmodule.PhaseAPC.getDefaultInstance() : lDCR_;
      }
    }
    /**
     * <pre>
     * Line drop voltage due to line resistance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCR = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder> 
        getLDCRFieldBuilder() {
      if (lDCRBuilder_ == null) {
        lDCRBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder>(
                getLDCR(),
                getParentForChildren(),
                isClean());
        lDCR_ = null;
      }
      return lDCRBuilder_;
    }

    private openfmb.commonmodule.PhaseAPC lDCX_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder> lDCXBuilder_;
    /**
     * <pre>
     * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
     * @return Whether the lDCX field is set.
     */
    public boolean hasLDCX() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
     * @return The lDCX.
     */
    public openfmb.commonmodule.PhaseAPC getLDCX() {
      if (lDCXBuilder_ == null) {
        return lDCX_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : lDCX_;
      } else {
        return lDCXBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
     */
    public Builder setLDCX(openfmb.commonmodule.PhaseAPC value) {
      if (lDCXBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        lDCX_ = value;
      } else {
        lDCXBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
     */
    public Builder setLDCX(
        openfmb.commonmodule.PhaseAPC.Builder builderForValue) {
      if (lDCXBuilder_ == null) {
        lDCX_ = builderForValue.build();
      } else {
        lDCXBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
     */
    public Builder mergeLDCX(openfmb.commonmodule.PhaseAPC value) {
      if (lDCXBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          lDCX_ != null &&
          lDCX_ != openfmb.commonmodule.PhaseAPC.getDefaultInstance()) {
          getLDCXBuilder().mergeFrom(value);
        } else {
          lDCX_ = value;
        }
      } else {
        lDCXBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
     */
    public Builder clearLDCX() {
      bitField0_ = (bitField0_ & ~0x00000008);
      lDCX_ = null;
      if (lDCXBuilder_ != null) {
        lDCXBuilder_.dispose();
        lDCXBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
     */
    public openfmb.commonmodule.PhaseAPC.Builder getLDCXBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getLDCXFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
     */
    public openfmb.commonmodule.PhaseAPCOrBuilder getLDCXOrBuilder() {
      if (lDCXBuilder_ != null) {
        return lDCXBuilder_.getMessageOrBuilder();
      } else {
        return lDCX_ == null ?
            openfmb.commonmodule.PhaseAPC.getDefaultInstance() : lDCX_;
      }
    }
    /**
     * <pre>
     * Line drop voltage due to line reactance component (forward power flow presumed) at rated current.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC LDCX = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder> 
        getLDCXFieldBuilder() {
      if (lDCXBuilder_ == null) {
        lDCXBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder>(
                getLDCX(),
                getParentForChildren(),
                isClean());
        lDCX_ = null;
      }
      return lDCXBuilder_;
    }

    private openfmb.commonmodule.PhaseAPC volSpt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder> volSptBuilder_;
    /**
     * <pre>
     * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
     * @return Whether the volSpt field is set.
     */
    public boolean hasVolSpt() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
     * @return The volSpt.
     */
    public openfmb.commonmodule.PhaseAPC getVolSpt() {
      if (volSptBuilder_ == null) {
        return volSpt_ == null ? openfmb.commonmodule.PhaseAPC.getDefaultInstance() : volSpt_;
      } else {
        return volSptBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
     */
    public Builder setVolSpt(openfmb.commonmodule.PhaseAPC value) {
      if (volSptBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        volSpt_ = value;
      } else {
        volSptBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
     */
    public Builder setVolSpt(
        openfmb.commonmodule.PhaseAPC.Builder builderForValue) {
      if (volSptBuilder_ == null) {
        volSpt_ = builderForValue.build();
      } else {
        volSptBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
     */
    public Builder mergeVolSpt(openfmb.commonmodule.PhaseAPC value) {
      if (volSptBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          volSpt_ != null &&
          volSpt_ != openfmb.commonmodule.PhaseAPC.getDefaultInstance()) {
          getVolSptBuilder().mergeFrom(value);
        } else {
          volSpt_ = value;
        }
      } else {
        volSptBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
     */
    public Builder clearVolSpt() {
      bitField0_ = (bitField0_ & ~0x00000010);
      volSpt_ = null;
      if (volSptBuilder_ != null) {
        volSptBuilder_.dispose();
        volSptBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
     */
    public openfmb.commonmodule.PhaseAPC.Builder getVolSptBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getVolSptFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
     */
    public openfmb.commonmodule.PhaseAPCOrBuilder getVolSptOrBuilder() {
      if (volSptBuilder_ != null) {
        return volSptBuilder_.getMessageOrBuilder();
      } else {
        return volSpt_ == null ?
            openfmb.commonmodule.PhaseAPC.getDefaultInstance() : volSpt_;
      }
    }
    /**
     * <pre>
     * (controllable) Voltage setpoint. Analog value (MX) feeds back the setpoint of the controller.
     * </pre>
     *
     * <code>.commonmodule.PhaseAPC VolSpt = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder> 
        getVolSptFieldBuilder() {
      if (volSptBuilder_ == null) {
        volSptBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseAPC, openfmb.commonmodule.PhaseAPC.Builder, openfmb.commonmodule.PhaseAPCOrBuilder>(
                getVolSpt(),
                getParentForChildren(),
                isClean());
        volSpt_ = null;
      }
      return volSptBuilder_;
    }

    private openfmb.commonmodule.PhaseDPC voltageSetPointEnabled_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseDPC, openfmb.commonmodule.PhaseDPC.Builder, openfmb.commonmodule.PhaseDPCOrBuilder> voltageSetPointEnabledBuilder_;
    /**
     * <pre>
     * Enable voltage set point
     * </pre>
     *
     * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
     * @return Whether the voltageSetPointEnabled field is set.
     */
    public boolean hasVoltageSetPointEnabled() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * Enable voltage set point
     * </pre>
     *
     * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
     * @return The voltageSetPointEnabled.
     */
    public openfmb.commonmodule.PhaseDPC getVoltageSetPointEnabled() {
      if (voltageSetPointEnabledBuilder_ == null) {
        return voltageSetPointEnabled_ == null ? openfmb.commonmodule.PhaseDPC.getDefaultInstance() : voltageSetPointEnabled_;
      } else {
        return voltageSetPointEnabledBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Enable voltage set point
     * </pre>
     *
     * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
     */
    public Builder setVoltageSetPointEnabled(openfmb.commonmodule.PhaseDPC value) {
      if (voltageSetPointEnabledBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        voltageSetPointEnabled_ = value;
      } else {
        voltageSetPointEnabledBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Enable voltage set point
     * </pre>
     *
     * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
     */
    public Builder setVoltageSetPointEnabled(
        openfmb.commonmodule.PhaseDPC.Builder builderForValue) {
      if (voltageSetPointEnabledBuilder_ == null) {
        voltageSetPointEnabled_ = builderForValue.build();
      } else {
        voltageSetPointEnabledBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Enable voltage set point
     * </pre>
     *
     * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
     */
    public Builder mergeVoltageSetPointEnabled(openfmb.commonmodule.PhaseDPC value) {
      if (voltageSetPointEnabledBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          voltageSetPointEnabled_ != null &&
          voltageSetPointEnabled_ != openfmb.commonmodule.PhaseDPC.getDefaultInstance()) {
          getVoltageSetPointEnabledBuilder().mergeFrom(value);
        } else {
          voltageSetPointEnabled_ = value;
        }
      } else {
        voltageSetPointEnabledBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Enable voltage set point
     * </pre>
     *
     * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
     */
    public Builder clearVoltageSetPointEnabled() {
      bitField0_ = (bitField0_ & ~0x00000020);
      voltageSetPointEnabled_ = null;
      if (voltageSetPointEnabledBuilder_ != null) {
        voltageSetPointEnabledBuilder_.dispose();
        voltageSetPointEnabledBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Enable voltage set point
     * </pre>
     *
     * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
     */
    public openfmb.commonmodule.PhaseDPC.Builder getVoltageSetPointEnabledBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getVoltageSetPointEnabledFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Enable voltage set point
     * </pre>
     *
     * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
     */
    public openfmb.commonmodule.PhaseDPCOrBuilder getVoltageSetPointEnabledOrBuilder() {
      if (voltageSetPointEnabledBuilder_ != null) {
        return voltageSetPointEnabledBuilder_.getMessageOrBuilder();
      } else {
        return voltageSetPointEnabled_ == null ?
            openfmb.commonmodule.PhaseDPC.getDefaultInstance() : voltageSetPointEnabled_;
      }
    }
    /**
     * <pre>
     * Enable voltage set point
     * </pre>
     *
     * <code>.commonmodule.PhaseDPC voltageSetPointEnabled = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.PhaseDPC, openfmb.commonmodule.PhaseDPC.Builder, openfmb.commonmodule.PhaseDPCOrBuilder> 
        getVoltageSetPointEnabledFieldBuilder() {
      if (voltageSetPointEnabledBuilder_ == null) {
        voltageSetPointEnabledBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.PhaseDPC, openfmb.commonmodule.PhaseDPC.Builder, openfmb.commonmodule.PhaseDPCOrBuilder>(
                getVoltageSetPointEnabled(),
                getParentForChildren(),
                isClean());
        voltageSetPointEnabled_ = null;
      }
      return voltageSetPointEnabledBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:regulatormodule.DirectionalATCC)
  }

  // @@protoc_insertion_point(class_scope:regulatormodule.DirectionalATCC)
  private static final openfmb.regulatormodule.DirectionalATCC DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.regulatormodule.DirectionalATCC();
  }

  public static openfmb.regulatormodule.DirectionalATCC getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<DirectionalATCC>
      PARSER = new com.google.protobuf.AbstractParser<DirectionalATCC>() {
    @java.lang.Override
    public DirectionalATCC parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<DirectionalATCC> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<DirectionalATCC> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.regulatormodule.DirectionalATCC getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

